import bpy
from .settingutils import tranlsations
from ..operators import *
from ..operators import draw_operator as op

class MagicTrailsSettings:

    is_baked = False

    def realtime_update( self ):
        pass
    def draw_layout( self, layout, show_options = None, draw_children = False, box = True ):
        pass
    
    def get_data( self, cache, offset ):

        return Matrix( cache[ max( 0, min( offset, len( cache ) - 1 )) ])

    def range_start( self ):

        scene = bpy.context.scene
        return scene.frame_current == scene.frame_start

    def set_transforms( self, mat ):

        obj = self.id_data
        if getattr( self, 'use_loc', True ):
            obj.location = mat.translation
        if getattr( self, 'use_rot', True ):
            obj.rotation_euler = mat.to_euler( )
            obj.rotation_quaternion = mat.to_quaternion( )
        if getattr( self, 'use_scale', True ):
            obj.scale = mat.to_scale( )
        
    def bake_in_range( self, start, end ):
        
        obj = self.id_data
        self.is_baked = True
        scene = bpy.context.scene
        mem_frame = scene.frame_current
        for f in range( start, end + 1 ):
            scene.frame_set( f )
            mat = self.controller.mtrail.settings.get_data( getattr( self, 'offset', 0 ))
            self.set_transforms( mat )
            for t in tranlsations:
                obj.keyframe_insert( t, frame = scene.frame_current )

        scene.frame_current = mem_frame
    
    def clear_bake( self ):

        anim = self.id_data.animation_data
        if anim:    
            action = anim.action
            for c in getattr( action, 'fcurves', []):
                if c.data_path in tranlsations:
                    action.fcurves.remove( c )
        self.is_baked = False
    
    def free( self, delete_children = False ):
        
        if delete_children:
            for c in getattr( self, 'children', [] ):
                c.mtrail.settings.free( )
        bpy.data.objects.remove( self.id_data )

    def reset_position( self ):
        pass

    def draw_info( self, layout, icon = 'NONE', icon_value = -1 ):

        row = layout.row( align = True )
        row.label( text = self.id_data.name, icon = icon, icon_value = icon_value )
        row.prop( self.id_data, 'hide_viewport', text = '' )
        op( row, MAGICTRAILS_OT_delete, text = '', icon = 'PANEL_CLOSE', overrides = {'object' : self.id_data })
    
    def draw_bake( self, layout, cls = None ):
        
        if not cls:
            cls = MAGICTRAILS_OT_bake
        is_baked = self.is_baked
        op( layout, cls, text = 'Clear Bake' if is_baked else 'Bake', icon = 'KEY_DEHLT' if is_baked else 'RENDER_ANIMATION', overrides = {'object':self.id_data}).clear_bake = is_baked

def get_classes( ):
    return ( )