import bpy
from bpy.app import handlers
from bpy.app.handlers import persistent

frame_cache = 1

@persistent
def post_frame_update( dummy ):

    scene = bpy.context.scene
    if scene.mtrail_is_baking:
        return
    global frame_cache
    current = scene.frame_current
    if current == frame_cache:
        return
    
    for settings in ( x.mtrail.settings for x in scene.objects if x.mtrail.is_controller ):
        settings.realtime_update( )
    for settings in ( x.mtrail.settings for x in scene.objects if x.mtrail.type in [ 'MESH', 'FOLLOWER' ]):
        settings.realtime_update( )
    frame_cache = current

def register_sim_handlers( register ):

    attr = 'append' if register else 'remove'
    getattr( handlers.load_post, attr )( post_frame_update )
    getattr( handlers.frame_change_post, attr )( post_frame_update )